#if !defined(AFX_VIEWTRANSFER_H__3C289741_2843_11D4_ACF2_00A0CC533D52__INCLUDED_)
#define AFX_VIEWTRANSFER_H__3C289741_2843_11D4_ACF2_00A0CC533D52__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ViewTransfer.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CViewTransfer form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include <string>
#include "ListCtrlEx.h"

class CViewTransfer : public CFormView
{
protected:
	CViewTransfer();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CViewTransfer)

// Form Data
public:
	//{{AFX_DATA(CViewTransfer)
	enum { IDD = IDD_VIEW_TRANSFER };
	CButton	m_CancelDown;
	CButton	m_CancelUp;
	CButton	m_btnPause;
	CStatic	m_stcUploads;
	CStatic	m_stcDownloads;
	CListCtrlEx	m_lstUploads;
	CListCtrlEx	m_lstDownloads;
	//}}AFX_DATA

// Attributes
public:
	UINT DownloadTimer;
	UINT UploadTimer;

// Operations
public:
	void NewDownload(QueryItem, SOCKET sock = NULL);
	void NewUpload(CString, SOCKET sock);

	void NewPushDownload(std::string& pushString, SOCKET sock);

	CGnuTransfer* GetQueryItem(int row, char);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CViewTransfer)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void m_UpdateDownloadButtons(void);
	bool m_bItemsChanged;
	void m_SaveAllTransfers(void);
	void m_ReadSavedTransfers(void);
	void RemoveRow(int row, char);
	virtual ~CViewTransfer();

	CGnucleusDoc *Doc;

	int UpdateRate;
	int FiveSecs;

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CViewTransfer)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnButtonCancelDown();
	afx_msg void OnButtonCancelUp();
	afx_msg void OnButtonPause();
	afx_msg void OnItemchangedListDownloads(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VIEWTRANSFER_H__3C289741_2843_11D4_ACF2_00A0CC533D52__INCLUDED_)
